# Embarcadero Dev-C++
A fast, portable, simple, and free C/C++ IDE. Dev C++ has been downloaded over 67,796,885 times since 2000.

Embarcadero Dev-C++ is a new and improved fork (sponsored by Embarcadero) of Bloodshed Dev-C++ and Orwell Dev-C++. It is a full-featured Integrated Development Environment (IDE) and code editor for the C/C++ programming language. It uses Mingw port of GCC (GNU Compiler Collection) as its compiler. Embarcadero Dev-C++ can also be used in combination with Cygwin or any other GCC based compiler. Embarcadero Dev-C++ is built using the latest version of Embarcadero Delphi. Embarcadero Dev-C++ has a low memory footprint because it is a native Windows application and does not use Electron.

Download the latest release:
<https://github.com/Embarcadero/Dev-Cpp/releases>

Main Features include:

- TDM-GCC 9.2.0 32/64bit
- Support GCC-based compilers
- Integrated debugging (using GDB)
- GPROF profiling
- Project Manager
- Customizable syntax highlighting editor
- Class Browser
- Code Completion
- Code Insight
- Function listing
- AStyle code formatting support
- GPROF Profiling support
- Quickly create Windows, console, static libraries and DLLs
- Support of templates for creating your own project types
- Makefile creation
- Edit and compile Resource files
- Tool Manager
- Devpak IDE extensions
- Print support
- Find and replace facilities
- CVS support

Supported Operating System:

- Windows 7
- Windows 8.1
- Windows 10

# Dev C++ Release Notes

Version 6.1 - 2 November 2020

 - Updated: C++ keyword highlighting. Added some C++20 keywords.
 - Updated: Font ligature support.
 - Updated: SVGIconImageList dependency
 - Updated: SynEdit dependency.
 - Updated: Text file loading and saving dialogs with Encodings.
 - Added: Visual Studio Dark theme.
 - Fixed: Automatic Tab widths.
 - Fixed: Launching help from directory with spaces.
 - Fixed: Welcome screen issue when canceling closing.
 - Fixed: Shortcuts Form dark styling.
 - Fixed: Crash in Issue #26.

Version 6.0 - 12 October 2020

- Upgraded TDM-GCC to 32/64 9.2.0.
- Upgraded compiler flags to reflect GCC 9.2.0 including c++17 and c++2a.
- Upgraded FastMM4 to FastMM5.
- Moved TDM-GCC to TDM-GCC-64 from MingW64.
- Added CMD and PowerShell console tabs.
- Added Windows 10, Windows 10 Slate Gray, and Windows 10 Blue Whale High DPI Styles
- Added new high DPI SVG icon set for the new Styles through the SVGIconImageList project.
- Added dialog styles through VCL Style Utils project.
- Added custom draw editor tabs and close buttons.
- Added saving and loading of UTF-8 characters.
- Updated Chinese language files and installer.
- Fixed crashes in AStyle dialog and unsaved formatting.
- Moved config file to My Documents\Embarcadero\Dev-Cpp
- Added new Welcome screen with shortcuts.
- Updated documentation theming.
- Added Heebo and Source Code Pro fonts for the interface and editor.
- Added Monokai and Monokai Fresh editor color schemes.
- Updated Packman with new Windows 10 Styles.

Version 5.50 - 1 July 2020

- Upgraded Packman to use Abbrevia
- Upgraded AStyle to 3.1
- Upgraded project to Delphi 10.4
- Project forked as Embarcadero Dev C++
- Project Sponsored by Embarcadero Technologies, Inc.


# Dev C++ Screenshot:

![Dev C++ Screenshot](https://raw.githubusercontent.com/Embarcadero/Dev-Cpp/master/Source/Images/screenshot800x600.png)

# Dev C++ Bundled Compiler

tdm-gcc: GCC compiler, Windows-friendly.
<https://jmeubank.github.io/tdm-gcc/>

# Dev C++ Third Party Libraries

"Artistic Style is a source code indenter, formatter, and beautifier for the C, C++, C++/CLI, Objective‑C, C# and Java programming languages."
<http://astyle.sourceforge.net/>

"SynEdit is a syntax highlighting edit control, not based on the Windows common controls. SynEdit is compatible with both Delphi and C++ Builder."
<https://github.com/TurboPack/SynEdit>

"FastMM is a fast replacement memory manager for Embarcadero Delphi applications that scales well across multiple threads and CPU cores."
<https://github.com/pleriche/FastMM5>

"VCL Styles Utils is a Delphi library which extend the RAD Studio VCL Styles."
<https://github.com/RRUZ/vcl-styles-utils>

"DDetours is a library allowing you to hook Delphi and Windows API functions."
<https://github.com/MahdiSafsafi/DDetours>

"Components to simplify use of SVG images (resize, fixedcolor, grayscale...). "
<https://github.com/EtheaDev/SVGIconImageList>

"Abbrevia is a compression toolkit for Delphi and C++Builder."
https://github.com/TurboPack/Abbrevia

"Monokai Theme"
<https://github.com/rbardini/devcpp-monokai>

"Monokai Fresh Theme"
<https://github.com/sspathare97/devcpp-monokai_fresh>

# Original Dev-C++ Developers

Find out more about the original developers of Bloodshed Dev-C++:

<https://www.bloodshed.net/devcpp.html>

# Built In Delphi

Find out more information about Embarcadero Delphi:

<https://www.embarcadero.com/products/delphi>
